const electron = window.require('electron');
const ipcRenderer = electron.ipcRenderer;

export const OcsApiReducerInitialState = {
    loading:true,
    installTypes:[],
    installedItems:[],
    installedItemTypes:[],
    updateItems:[],
    downloadItems:[]
}

function OcsApiReducer(state,action){
    switch(action.type){
        case 'SET_API':{
            return { ...state, ocsManagerApi:action.ocsManagerApi,loading:false}
        }
        case 'SET_INSTALL_TYPES':{
            return { ...state, installTypes:action.installTypes}
        }
        case 'SET_INSTALLED_ITEMS':{
            const installedItems = Object.keys(action.installedItems).map((k) => action.installedItems[k]);
            let installedItemTypes = [];
            installedItems.forEach(function(item,index){
                const installedItemType = item.install_type;
                if (installedItemTypes.indexOf(installedItemType) === -1) installedItemTypes.push(installedItemType);
            });
            return { ...state, installedItems:installedItems, installedItemTypes:installedItemTypes }
        }
        case 'SET_DOWNLOAD_ITEM':{
            const item = { ...action.item,status:'Downloading' }
            console.log(item);
            const downloadItems = [ ...state.downloadItems, item ]
            return { ...state, downloadItems:downloadItems}
        }
        case 'UPDATE_ITEM_DOWNLOAD_PROGRESS':{
            const downloadItemIndex = state.downloadItems.findIndex((item) => item.url === action.itemUrl);
            const newDownloadItem = { ...state.downloadItems[downloadItemIndex] }
            if (action.bytesRecieved) newDownloadItem.bytesRecieved = action.bytesRecieved;
            if (action.bytesTotal) newDownloadItem.bytesTotal = action.bytesTotal
            if (action.status) newDownloadItem.status = action.status;
            const downloadItems = [
                ...state.downloadItems.slice(0,downloadItemIndex),
                newDownloadItem,
                ...state.downloadItems.slice(downloadItemIndex + 1, state.downloadItems.length)
            ];
            return { ...state, downloadItems:downloadItems }
        }
        case 'SET_UPDATE_CHECK':{
            return { ...state, updateCheckedAt:action.updateCheckedAt,updateCheckAfter:action.updateCheckAfter}
        }
        default: {
            return state;
        }
    }
}

export default OcsApiReducer;